package de.ok.vc_02;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.graphics.Color;
import android.view.View;
import android.widget.Button;
import android.os.AsyncTask;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.ToggleButton;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

public class MainActivity extends AppCompatActivity {

    TextView htmlTv;
    String espCmd;
    EditText ipText;
    SeekBar volumeBar;
    TextView volumeBarView;
    String sResponse;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

    final Button ch1Button = (Button) findViewById(R.id.ch1Btn);
    final Button ch2Button = (Button) findViewById(R.id.ch2Btn);
    final Button ch3Button = (Button) findViewById(R.id.ch3Btn);
    final Button ch4Button = (Button) findViewById(R.id.ch4Btn);
    final ToggleButton muteOnOffBtn = (ToggleButton) findViewById(R.id.muteOnOffBtn);
    ipText = (EditText) findViewById(R.id.editIP);
    htmlTv = (TextView) findViewById(R.id.htmlTv);
    volumeBar = (SeekBar) findViewById(R.id.volumeBar);
    volumeBarView = (TextView) findViewById(R.id.volumeBarView);
    sResponse = "";

    espCmd = "http://" + ipText.getText() + "/?type=ANDROID";
        new goToMyESP(espCmd).execute();

        volumeBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener()
    {
        int progress = 0;

        @Override
        public void onProgressChanged(SeekBar volumeBar, int progresValue, boolean fromUser)
        {
            progress = progresValue;
            volumeBar.setMax(255);
            volumeBarView.setText("Volume: " + progress + " of " + volumeBar.getMax());
            //new goToMyESP(ipText.getText() + "/?volume=" + progress).execute();
        }
        @Override
        public void onStartTrackingTouch(SeekBar volumeBar)
        {
            //Toast.makeText(getApplicationContext(), "Started tracking seekbar", Toast.LENGTH_SHORT).show();
        }
        @Override
        public void onStopTrackingTouch(SeekBar volumeBar)
        {
            espCmd = "http://" + ipText.getText() + "/?type=ANDROID";
            new goToMyESP(espCmd).execute();
            //volumeBarView.setText("Volume: " + progress + "/" + volumeBar.getMax());
            espCmd = "http://" + ipText.getText() + "/?volume=" + progress;
            new goToMyESP(espCmd).execute();
        }
    });

        ch1Button.setOnClickListener(new View.OnClickListener()
    {
        public void onClick(View v)
        {
            espCmd = "http://" + ipText.getText() + "/?type=ANDROID";
            new goToMyESP(espCmd).execute();
            espCmd = "http://" + ipText.getText() + "/?channel=1";
            ch1Button.setBackgroundColor(Color.parseColor("#30FFFFFF"));
            ch2Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch3Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch4Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            new goToMyESP(espCmd).execute();
        }
    });
        ch2Button.setOnClickListener(new View.OnClickListener()
    {
        public void onClick(View v)
        {
            espCmd = "http://" + ipText.getText() + "/?type=ANDROID";
            new goToMyESP(espCmd).execute();
            espCmd = "http://" + ipText.getText() + "/?channel=2";
            ch2Button.setBackgroundColor(Color.parseColor("#30FFFFFF"));
            ch1Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch3Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch4Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            new goToMyESP(espCmd).execute();
        }
    });
        ch3Button.setOnClickListener(new View.OnClickListener()
    {
        public void onClick(View v)
        {
            espCmd = "http://" + ipText.getText() + "/?type=ANDROID";
            new goToMyESP(espCmd).execute();
            espCmd = "http://" + ipText.getText() + "/?channel=3";
            ch3Button.setBackgroundColor(Color.parseColor("#30FFFFFF"));
            ch1Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch2Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch4Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            new goToMyESP(espCmd).execute();
        }
    });
        ch4Button.setOnClickListener(new View.OnClickListener()
    {
        public void onClick(View v)
        {
            espCmd = "http://" + ipText.getText() + "/?type=ANDROID";
            new goToMyESP(espCmd).execute();
            espCmd = "http://" + ipText.getText() + "/?channel=4";
            ch4Button.setBackgroundColor(Color.parseColor("#30FFFFFF"));
            ch1Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch2Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            ch3Button.setBackgroundColor(Color.parseColor("#00FFFFFF"));
            new goToMyESP(espCmd).execute();
        }
    });

        muteOnOffBtn.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
        public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
            espCmd = "http://" + ipText.getText() + "/?type=ANDROID";
            new goToMyESP(espCmd).execute();
            if (isChecked) {
                muteOnOffBtn.setBackgroundColor(Color.parseColor("#20FFFFFF"));
                espCmd = "http://" + ipText.getText() + "/?mute=1";
                new goToMyESP(espCmd).execute();
            } else {
                muteOnOffBtn.setBackgroundColor(Color.parseColor("#00FFFFFF"));
                espCmd = "http://" + ipText.getText() + "/?mute=0";
                new goToMyESP(espCmd).execute();
            }
        }
    });

}

private class goToMyESP extends AsyncTask<Void, Void, String>
{

    String calledURL;

    goToMyESP(String calledURL)
    {
        this.calledURL = calledURL;
    }

    @Override
    protected String doInBackground(Void... params)
    {
        HttpURLConnection urlConnection = null;
        BufferedReader reader = null;
        URL url;
        String forecastJsonStr = null;
        try
        {
            url = new URL(calledURL);
            urlConnection = (HttpURLConnection) url.openConnection();
            urlConnection.setRequestMethod("GET");
            urlConnection.connect();
            InputStream inputStream = urlConnection.getInputStream();
            StringBuffer buffer = new StringBuffer();
            if (inputStream == null)
            {
                return "no answer from server";
            }
            reader = new BufferedReader(new InputStreamReader(inputStream));
            String line;
            while ((line = reader.readLine()) != null)
            {
                buffer.append(line + "\n");
            }
            if (buffer.length() == 0)
            {
                return "no answer from server";
            }
            forecastJsonStr = buffer.toString();
            return forecastJsonStr;
        } catch (IOException e) {
            return "IO-Error!";
        } finally {
            if (urlConnection != null)
            {
                urlConnection.disconnect();
            }
            if (reader != null)
            {
                try
                {
                    reader.close();
                } catch (final IOException e)
                {
                    return "finally IO-Error reading server!";
                }
            }
        }
    }

    @Override
    protected void onPostExecute(String s) {
        super.onPostExecute(s);
        htmlTv.setText(s);
    }
}



        }
